
/******************************************************************************

    MODULE
	PathPart.c

    DESCRIPTION
	Get one string on Commandline
	and write its PathPart to StdOut

    NOTES
	Kickstart 2.0+ required
	compiles w/ Dice 2.07R - inline-pragmas required
	compiles w/ SAS/C v6.51

    BUGS
	none known

    TODO

    EXAMPLES
	> pathpart ram:t/jabba.bak
	ram:t/

    SEE ALSO
	Suffix, FilePart

    INDEX

    HISTORY
	01-08-93 b_noll created

    AUTHOR
	Bernd Noll, Brunnenstrasse 55, D-67661 Kaiserslautern
	b_noll@informatik.uni-kl.de

******************************************************************************/

/**************************************
	    Includes
**************************************/

#ifndef   EXEC_LIBRARIES_H
# include <exec/libraries.h>
#endif /* EXEC_LIBRARIES_H */

#ifndef   CLIB_EXEC_PROTOS_H
# include <clib/exec_protos.h>
#endif /* CLIB_EXEC_PROTOS_H */

#ifndef   DOS_DOS_H
# include <dos/dos.h>
#endif /* DOS_DOS_H */

#ifndef   CLIB_DOS_PROTOS_H
# include <clib/dos_protos.h>
#endif /* CLIB_DOS_PROTOS_H */

#include <proto/dos.h>
#include <proto/exec.h>

/**************************************
	    Global Variables
**************************************/


/**************************************
	    Implementation
**************************************/

long _main (void)
{
    const char* version = "$VER: PathPart 1.0 (23.8.93)";
    long retval = 20;
    struct Library* SysBase = *((struct Library**)4L);
    struct Library* DOSBase;

    if (DOSBase = OpenLibrary (DOSNAME, 37)) {
	STRPTR argv[2] = { NULL, NULL };
	APTR   args;
	retval	 = 10;
	if (args = (void*)ReadArgs("FILE/A", (LONG*)argv, NULL)) {
	    char * p; char c;
	    p = PathPart(argv[0]);
	    c = *p; *p = 0;
	    retval = 5;
	    if (PutStr (argv[0]) == 0) retval = 0;
	    PutStr("\n");
	    *p = c;
	    FreeArgs (args);
	} /* if */
	CloseLibrary (DOSBase);
    } /* if */
    return (retval);
} /* _main */

/******************************************************************************
*****  END PathPart.c
******************************************************************************/

